Package org.picocontainer

# Interface PicoContainer

All Known Subinterfaces:
  `ClassLoadingPicoContainer`, `MutablePicoContainer`

All Known Implementing Classes:
  `AbstractDelegatingMutablePicoContainer`, `AbstractDelegatingPicoContainer`, `CommandLineArgumentsPicoContainer`, `CommandLinePicoContainer`, `CompositePicoContainer`, `DefaultClassLoadingPicoContainer`, `DefaultPicoContainer`, `EmptyPicoContainer`, `ImmutablePicoContainer`, `PropertiesPicoContainer`, `SystemPropertiesPicoContainer`, `TieringPicoContainer`, `TransientPicoContainer`

public interface PicoContainer
This is the core interface for PicoContainer. It is used to retrieve component instances from the container; it only has accessor methods (in addition to the `accept(PicoVisitor)` method). In order to register components in a PicoContainer, use a `MutablePicoContainer`, such as `DefaultPicoContainer`.

Author:
  Paul Hammant, Aslak Hellesøy, Jon Tirsén
See Also:
  - See package description for basic overview how to use PicoContainer.

## Method Summary

Modifier and Type
Method
Description
`void`
`accept(PicoVisitor visitor)`
Accepts a visitor that should visit the child containers, component adapters and component instances.
`<T> T`
`getComponent(Class<T> componentType)`
Retrieve a component keyed by the component type.
`<T> T`
`getComponent(Class<T> componentType, Class<? extends Annotation> binding)`
Retrieve a component keyed by the component type and binding type.
`Object`
`getComponent(Object componentKeyOrType)`
Retrieve a component instance registered with a specific key or type.
`Object`
`getComponent(Object componentKeyOrType, Type into)`
`<T> ComponentAdapter<T>`
`getComponentAdapter(Class<T> componentType, Class<? extends Annotation> binding)`
Find a component adapter associated with the specified type and binding type.
`<T> ComponentAdapter<T>`
`getComponentAdapter(Class<T> componentType, NameBinding componentNameBinding)`
Find a component adapter associated with the specified type and binding name.
`ComponentAdapter<?>`
`getComponentAdapter(Object componentKey)`
Find a component adapter associated with the specified key.
`Collection<ComponentAdapter<?>>`
`getComponentAdapters()`
Retrieve all the component adapters inside this container.
`<T> List<ComponentAdapter<T>>`
`getComponentAdapters(Class<T> componentType)`
Retrieve all component adapters inside this container that are associated with the specified type.
`<T> List<ComponentAdapter<T>>`
`getComponentAdapters(Class<T> componentType, Class<? extends Annotation> binding)`
Retrieve all component adapters inside this container that are associated with the specified type and binding type.
`List<Object>`
`getComponents()`
Retrieve all the registered component instances in the container, (not including those in the parent container).
`<T> List<T>`
`getComponents(Class<T> componentType)`
Returns a List of components of a certain componentType.
`PicoContainer`
`getParent()`
Retrieve the parent container of this container.

## Method Details

### getComponent

Object getComponent(Object componentKeyOrType)
Retrieve a component instance registered with a specific key or type. If a component cannot be found in this container, the parent container (if one exists) will be searched.

Parameters:
  `componentKeyOrType` - the key or Type that the component was registered with.
Returns:
  an instantiated component, or `null` if no component has been registered for the specified key.

### getComponent

Object getComponent(Object componentKeyOrType, Type into)

### getComponent

<T> T getComponent(Class<T> componentType)
Retrieve a component keyed by the component type.

Parameters:
  `componentType` - the type of the component
Returns:
  the typed resulting object instance or null if the object does not exist.

### getComponent

<T> T getComponent(Class<T> componentType, Class<? extends Annotation> binding)
Retrieve a component keyed by the component type and binding type.

Parameters:
  `componentType` - the type of the component
  `binding` - the binding type of the component
Returns:
  the typed resulting object instance or null if the object does not exist.

### getComponents

List<Object> getComponents()
Retrieve all the registered component instances in the container, (not including those in the parent container). The components are returned in their order of instantiation, which depends on the dependency order between them.

Returns:
  all the components.
Throws:
  `PicoException` - if the instantiation of the component fails

### getParent

PicoContainer getParent()
Retrieve the parent container of this container.

Returns:
  a `PicoContainer` instance, or `null` if this container does not have a parent.

### getComponentAdapter

ComponentAdapter<?> getComponentAdapter(Object componentKey)
Find a component adapter associated with the specified key. If a component adapter cannot be found in this container, the parent container (if one exists) will be searched.

Parameters:
  `componentKey` - the key that the component was registered with.
Returns:
  the component adapter associated with this key, or `null` if no component has been registered for the specified key.

### getComponentAdapter

<T> ComponentAdapter<T> getComponentAdapter(Class<T> componentType, NameBinding componentNameBinding)
Find a component adapter associated with the specified type and binding name. If a component adapter cannot be found in this container, the parent container (if one exists) will be searched.

Parameters:
  `componentType` - the type of the component.
  `componentNameBinding` - the name binding to use
Returns:
  the component adapter associated with this class, or `null` if no component has been registered for the specified key.

### getComponentAdapter

<T> ComponentAdapter<T> getComponentAdapter(Class<T> componentType, Class<? extends Annotation> binding)
Find a component adapter associated with the specified type and binding type. If a component adapter cannot be found in this container, the parent container (if one exists) will be searched.

Parameters:
  `componentType` - the type of the component.
  `binding` - the typed binding to use
Returns:
  the component adapter associated with this class, or `null` if no component has been registered for the specified key.

### getComponentAdapters

Collection<ComponentAdapter<?>> getComponentAdapters()
Retrieve all the component adapters inside this container. The component adapters from the parent container are not returned.

Returns:
  a collection containing all the `ComponentAdapter`s inside this container. The collection will not be modifiable.
See Also:
  - `a variant of this method which returns the component adapters inside this container that are associated with the specified type.`

### getComponentAdapters

<T> List<ComponentAdapter<T>> getComponentAdapters(Class<T> componentType)
Retrieve all component adapters inside this container that are associated with the specified type. The addComponent adapters from the parent container are not returned.

Parameters:
  `componentType` - the type of the components.
Returns:
  a collection containing all the `ComponentAdapter`s inside this container that are associated with the specified type. Changes to this collection will not be reflected in the container itself.

### getComponentAdapters

<T> List<ComponentAdapter<T>> getComponentAdapters(Class<T> componentType, Class<? extends Annotation> binding)
Retrieve all component adapters inside this container that are associated with the specified type and binding type. The addComponent adapters from the parent container are not returned.

Parameters:
  `componentType` - the type of the components.
  `binding` - the typed binding to use
Returns:
  a collection containing all the `ComponentAdapter`s inside this container that are associated with the specified type. Changes to this collection will not be reflected in the container itself.

### getComponents

<T> List<T> getComponents(Class<T> componentType)
Returns a List of components of a certain componentType. The list is ordered by instantiation order, starting with the components instantiated first at the beginning.

Parameters:
  `componentType` - the searched type.
Returns:
  a List of components.
Throws:
  `PicoException` - if the instantiation of a component fails

### accept

void accept(PicoVisitor visitor)
Accepts a visitor that should visit the child containers, component adapters and component instances.

Parameters:
  `visitor` - the visitor